'use strict';

exports.__esModule = true;
exports.noop = noop;
exports.createImmState = createImmState;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

function noop() {}

function createImmState(context) {
  var field = arguments.length <= 1 || arguments[1] === undefined ? 'data' : arguments[1];
  var callback = arguments.length <= 2 || arguments[2] === undefined ? noop : arguments[2];

  _invariant2['default'](typeof context === 'object', '`context` should be an object');
  _invariant2['default'](typeof field === 'string', '`field` should be a string');
  _invariant2['default'](field, '`field` should not be empty');
  _invariant2['default'](typeof callback === 'function', '`callback` should be a function');

  return function (func) {
    return context.setState(function (prevState) {
      var _ref;

      return (_ref = {}, _ref[field] = func(prevState[field]), _ref);
    }, callback);
  };
}